' ****************************************************************************************
' This code is copied and adapted from WinFBX with explicit permission of Jos Roca 
' under the condition that the original copyright applies (see below). 
' All changes and additions are Copyright (c) 2018 Juergen Kuehlwein
' Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ****************************************************************************************

' ########################################################################################
' Microsoft Windows
' Implements a dynamic data type for null terminated unicode strings.
' Compiler: Free Basic 32 & 64 bit
' Copyright (c) 2016 Paul Squires & Jos Roca, with the collaboration of Marc Pons.
' Freeware. Use at your own risk.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
' EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
' MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ########################################################################################


const crlf = !"\r\n"
const cr = !"\r"
const lf = !"\n"
'const tab = !"\t"
'const spc = " "
const dq = chr(34)

'***********************************************************************************************
' define constants for string helper functions
' convert $ to _, if space, comma or "(" follows  
'***********************************************************************************************

const path_ = 1                                       'path$
const any_ = 1                                        'any$
const name_ = 2                                       'name$
const namex_ = 3                                      'namex$
const extn_ = 4                                       'extn$
const case_ = 1                                       'case$


#define RGBV bgr                                      'for RGB values


#macro STRINGSET                                      'add "USTRING" and set "DSTR" and "ZSTR"
'***********************************************************************************************
' add USTRING as dynamc Unicode string type
'***********************************************************************************************
#ifndef ustring
  #ifdef afx                                          'if WinFBX is present
    #ifndef cwstr                                     'if WinFBX is not used
      #define ustring jk.jK_CWSTR                     'use replacement

    #else
      #define ustring afx.CBSTR                       'use WinFBXs dynamic Unicode string 

    #endif

  #else
    #define ustring jk.jK_CBSTR                       'use replacement
  #endif
#endif

#ifdef unicode   
  #ifndef dstr                                        'dynamic unicode string
    #define dstr ustring                              '(jk_CWstr/CBstr)
  #endif  
  #ifndef zstr                                        'zero terminated unicode string (* bytes)
    #define zstr wstring
  #endif  
#ELSE
  #ifndef dstr                                        'dynamic ansi string
    #define dstr string
  #endif  
  #ifndef zstr                                        'zero terminated ansi string (* bytes)
    #define zstr zstring
  #endif  
#ENDIF

#include str_inc                                      'STR_INC = filespec for "fb_str.inc"
#endmacro


'***********************************************************************************************
' define color constants for convenience
'***********************************************************************************************

const  AliceBlue = &hFFF0F8FF
const  AntiqueWhite = &hFFFAEBD7
const  Aqua = &hFF00FFFF
const  Aquamarine = &hFF7FFFD4
const  Azure = &hFFF0FFFF
const  Beige = &hFFF5F5DC
const  Bisque = &hFFFFE4C4
const  Black = &hFF000000
const  BlanchedAlmond = &hFFFFEBCD
const  Blue = &hFF0000FF
const  BlueViolet = &hFF8A2BE2
const  Brown = &hFFA52A2A
const  BurlyWood = &hFFDEB887
const  CadetBlue = &hFF5F9EA0
const  Chartreuse = &hFF7FFF00
const  Chocolate = &hFFD2691E
const  Coral = &hFFFF7F50
const  CornflowerBlue = &hFF6495ED
const  Cornsilk = &hFFFFF8DC
const  Crimson = &hFFDC143C
const  Cyan = &hFF00FFFF
const  DarkBlue = &hFF00008B
const  DarkCyan = &hFF008B8B
const  DarkGoldenrod = &hFFB8860B
const  DarkGray = &hFFA9A9A9
const  DarkGreen = &hFF006400
const  DarkKhaki = &hFFBDB76B
const  DarkMagenta = &hFF8B008B
const  DarkOliveGreen = &hFF556B2F
const  DarkOrange = &hFFFF8C00
const  DarkOrchid = &hFF9932CC
const  DarkRed = &hFF8B0000
const  DarkSalmon = &hFFE9967A
const  DarkSeaGreen = &hFF8FBC8B
const  DarkSlateBlue = &hFF483D8B
const  DarkSlateGray = &hFF2F4F4F
const  DarkTurquoise = &hFF00CED1
const  DarkViolet = &hFF9400D3
const  DeepPink = &hFFFF1493
const  DeepSkyBlue = &hFF00BFFF
const  DimGray = &hFF696969
const  DodgerBlue = &hFF1E90FF
const  Firebrick = &hFFB22222
const  FloralWhite = &hFFFFFAF0
const  ForestGreen = &hFF228B22
const  Fuchsia = &hFFFF00FF
const  Gainsboro = &hFFDCDCDC
const  GhostWhite = &hFFF8F8FF
const  Gold = &hFFFFD700
const  Goldenrod = &hFFDAA520
const  Gray = &hFF808080
const  Green = &hFF008000
const  GreenYellow = &hFFADFF2F
const  Honeydew = &hFFF0FFF0
const  HotPink = &hFFFF69B4
const  IndianRed = &hFFCD5C5C
const  Indigo = &hFF4B0082
const  Ivory = &hFFFFFFF0
const  Khaki = &hFFF0E68C
const  Lavender = &hFFE6E6FA
const  LavenderBlush = &hFFFFF0F5
const  LawnGreen = &hFF7CFC00
const  LemonChiffon = &hFFFFFACD
const  LightBlue = &hFFADD8E6
const  LightCoral = &hFFF08080
const  LightCyan = &hFFE0FFFF
const  LightGoldenrodYellow = &hFFFAFAD2
const  LightGray = &hFFD3D3D3
const  LightGreen = &hFF90EE90
const  LightPink = &hFFFFB6C1
const  LightSalmon = &hFFFFA07A
const  LightSeaGreen = &hFF20B2AA
const  LightSkyBlue = &hFF87CEFA
const  LightSlateGray = &hFF778899
const  LightSteelBlue = &hFFB0C4DE
const  LightYellow = &hFFFFFFE0
const  Lime = &hFF00FF00
const  LimeGreen = &hFF32CD32
const  Linen = &hFFFAF0E6
const  Magenta = &hFFFF00FF
const  Maroon = &hFF800000
const  MediumAquamarine = &hFF66CDAA
const  MediumBlue = &hFF0000CD
const  MediumOrchid = &hFFBA55D3
const  MediumPurple = &hFF9370DB
const  MediumSeaGreen = &hFF3CB371
const  MediumSlateBlue = &hFF7B68EE
const  MediumSpringGreen = &hFF00FA9A
const  MediumTurquoise = &hFF48D1CC
const  MediumVioletRed = &hFFC71585
const  MidnightBlue = &hFF191970
const  MintCream = &hFFF5FFFA
const  MistyRose = &hFFFFE4E1
const  Moccasin = &hFFFFE4B5
const  NavajoWhite = &hFFFFDEAD
const  Navy = &hFF000080
const  OldLace = &hFFFDF5E6
const  Olive = &hFF808000
const  OliveDrab = &hFF6B8E23
const  Orange = &hFFFFA500
const  OrangeRed = &hFFFF4500
const  Orchid = &hFFDA70D6
const  PaleGoldenrod = &hFFEEE8AA
const  PaleGreen = &hFF98FB98
const  PaleTurquoise = &hFFAFEEEE
const  PaleVioletRed = &hFFDB7093
const  PapayaWhip = &hFFFFEFD5
const  PeachPuff = &hFFFFDAB9
const  Peru = &hFFCD853F
const  Pink = &hFFFFC0CB
const  Plum = &hFFDDA0DD
const  PowderBlue = &hFFB0E0E6
const  Purple = &hFF800080
const  Red = &hFFFF0000
const  RosyBrown = &hFFBC8F8F
const  RoyalBlue = &hFF4169E1
const  SaddleBrown = &hFF8B4513
const  Salmon = &hFFFA8072
const  SandyBrown = &hFFF4A460
const  SeaGreen = &hFF2E8B57
const  SeaShell = &hFFFFF5EE
const  Sienna = &hFFA0522D
const  Silver = &hFFC0C0C0
const  SkyBlue = &hFF87CEEB
const  SlateBlue = &hFF6A5ACD
const  SlateGray = &hFF708090
const  Snow = &hFFFFFAFA
const  SpringGreen = &hFF00FF7F
const  SteelBlue = &hFF4682B4
const  Tan_ = &hFFD2B48C
const  Teal = &hFF008080
const  Thistle = &hFFD8BFD8
const  Tomato = &hFFFF6347
const  Transparent_ = &h00FFFFFF
const  Turquoise = &hFF40E0D0
const  Violet = &hFFEE82EE
const  Wheat = &hFFF5DEB3
const  White = &hFFFFFFFF
const  WhiteSmoke = &hFFF5F5F5
const  Yellow = &hFFFFFF00
const  YellowGreen = &hFF9ACD32


'***********************************************************************************************
' replacement for Jos Rocas CWstr, if WinFBX is not present or is not used.
' this is mostly a clone of his code with a "JK_" prefix
'***********************************************************************************************

common shared JK__mtwc as function(BYVAL CodePage AS Ulong, BYVAL dwFlags AS Ulong, BYVAL lpMultiByteStr AS zstring ptr, _
              BYVAL cbMultiByte AS LONG, BYVAL lpWideCharStr AS wstring ptr, BYVAL cchWideChar AS LONG) AS long


common shared JK__wctm as function(BYVAL CodePage AS Ulong, BYVAL dwFlags AS ulong, BYVAL lpWideCharStr AS wstring ptr, _
              BYVAL cchWideChar AS LONG, BYVAL lpMultiByteStr AS zstring ptr, BYVAL cbMultiByte AS LONG, BYVAL lpDefaultChar AS byte ptr, BYVAL lpUsedDefaultChar AS Long ptr) AS long


Dim As Any Ptr JK__k_library = Dylibload("Kernel32.dll")
  JK__mtwc = Dylibsymbol(JK__k_library, "MultiByteToWideChar")
  JK__wctm = Dylibsymbol(JK__k_library, "WideCharToMultiByte")


CONST JK__CP_UTF8 = 65001
CONST JK__MB_PRECOMPOSED = &h00000001


#ifdef  __FB_64BIT__
sub mcpy(dest as any ptr, src as any ptr, count as uinteger)
'***********************************************************************************************
' memcpy replacement
'***********************************************************************************************

asm
'  push rdi
'  push rsi
  push rcx

  mov rdi, [dest]                                     'destination
  mov rsi, [src]                                      'source
  mov rcx, [count]                                    '# of byte to copy

  shr rcx, 3                                          '/4
  cld
  
  rep movsq                                           'copy qwords

  mov rcx, [count]
  and rcx, 7                                          'mod 8

  rep movsb                                           'copy bytes
  
  pop rcx
'  pop rsi
'  pop rdi
end asm

end sub

#else

sub mcpy(dest as any ptr, src as any ptr, count as Ulong)
'***********************************************************************************************
' memcpy replacement
'***********************************************************************************************

asm
'  push edi
'  push esi
  push ecx

  mov edi, [dest]                                     'destination
  mov esi, [src]                                      'source
  mov ecx, [count]                                    '# of byte to copy

  shr ecx, 2                                          '/4
  cld
  
  rep movsd                                           'copy dwords

  mov ecx, [count]
  and ecx, 3                                          'mod 4

  rep movsb                                           'copy bytes
  
  pop ecx
'  pop esi
'  pop edi
end asm

end sub

#endif


''***********************************************************************************************
''***********************************************************************************************


#pragma ONCE


#ifndef AFX_BSTR
   #define AFX_BSTR WSTRING PTR
#ENDIF


NAMESPACE JK                                          'obviously i cannot use "AFX" here


' // Forward reference
TYPE JK_CWSTR_ AS JK_CWSTR

' ========================================================================================
' Macro for debug
' To allow debugging, define _JK_CWSTR_DEBUG_ 1 in your application before including this file.
' ========================================================================================
#ifndef _JK_CWSTR_DEBUG_
   #define _JK_CWSTR_DEBUG_ 0
#ENDIF
#ifndef _JK_CWSTR_DP_
   #define _JK_CWSTR_DP_ 1
   #MACRO JK_CWSTR_DP(st)
      #IF (_JK_CWSTR_DEBUG_ = 1)
         OutputDebugStringW(st)
      #ENDIF
   #ENDMACRO
#ENDIF
' ========================================================================================

' ========================================================================================
' Macro for debug
' To allow debugging, define _CBSTR_DEBUG_ 1 in your application before including this file.
' ========================================================================================
#ifndef _CBSTR_DEBUG_
   #define _CBSTR_DEBUG_ 0
#ENDIF
#ifndef _CBSTR_DP_
   #define _CBSTR_DP_ 1
   #MACRO CBSTR_DP(st)
      #IF (_CBSTR_DEBUG_ = 1)
         OutputDebugStringW(st)
      #ENDIF
   #ENDMACRO
#ENDIF
' ========================================================================================

' ========================================================================================
' // Checks if the passed pointer is a BSTR.
' // Will return FALSE if it is a null pointer.
' // If it is an OLE string it must have a descriptor; otherwise, don't.
' // Get the length in bytes looking at the descriptor and divide by 2 to get the number of
' // unicode characters, that is the value returned by the FreeBASIC LEN operator.
' // If the retrieved length if the same that the returned by LEN, then it must be an OLE string.
' ========================================================================================


'FUNCTION AfxIsBstr (BYVAL pv aS ANY PTR) AS BOOLEAN
'   IF pv = NULL THEN RETURN FALSE
'   DIM res AS DWORD = PEEK(DWORD, pv - 4) \ 2
'   IF res = LEN(*cast(WSTRING PTR, pv)) THEN RETURN TRUE
'END FUNCTION
' ========================================================================================


' ########################################################################################
'                                  *** JK_CWSTR CLASS ***
' ########################################################################################
TYPE JK_CWSTR

   Private:
      m_Capacity AS Ulong            ' The total size of the buffer
      m_GrowSize AS LONG = 260 * 2  ' How much to grow the buffer by when required
      m_CodePage AS ulong            ' Unicode code page

   Public:
      m_pBuffer AS UBYTE PTR        ' Pointer to the buffer
      m_BufferLen AS ulong           ' Length in bytes of the current string in the buffer

      DECLARE CONSTRUCTOR
      DECLARE CONSTRUCTOR (BYVAL nChars AS ulong, BYVAL nCodePage AS ulong)
      DECLARE CONSTRUCTOR (BYVAL pwszStr AS WSTRING PTR)
      DECLARE CONSTRUCTOR (BYREF ansiStr AS STRING, BYVAL nCodePage AS ulong = 0)
      DECLARE CONSTRUCTOR (BYREF cws AS JK_CWSTR)
'      DECLARE CONSTRUCTOR (BYREF cbs AS CBSTR_)
      DECLARE CONSTRUCTOR (BYVAL n AS LONGINT)
      DECLARE CONSTRUCTOR (BYVAL n AS DOUBLE)
      DECLARE DESTRUCTOR
      DECLARE SUB ResizeBuffer (BYVAL nValue AS ulong)
      DECLARE FUNCTION AppendBuffer (BYVAL addrMemory AS ANY PTR, BYVAL nNumBytes AS ulong) AS BOOLEAN
      DECLARE FUNCTION InsertBuffer (BYVAL addrMemory AS ANY PTR, BYVAL nIndex AS ulong, BYVAL nNumBytes AS ulong) AS BOOLEAN
      DECLARE PROPERTY GrowSize () AS LONG
      DECLARE PROPERTY GrowSize (BYVAL nValue AS LONG)
      DECLARE PROPERTY Capacity () AS ulong
      DECLARE PROPERTY Capacity (BYVAL nValue AS ulong)
      DECLARE PROPERTY SizeAlloc (BYVAL nChars AS ulong)
      DECLARE PROPERTY SizeOf () AS ulong
      DECLARE PROPERTY CodePage () AS ulong
      DECLARE PROPERTY CodePage (BYVAL nCodePage AS ulong)
      DECLARE SUB Clear
      DECLARE SUB Resize (BYVAL nSize AS ulong, BYREF ch AS WSTRING = "")
      DECLARE SUB Add (BYREF cws AS JK_CWSTR)
'      DECLARE SUB Add (BYREF cbs AS CBSTR_)
      DECLARE SUB Add (BYVAL pwszStr AS WSTRING PTR)
      DECLARE SUB Add (BYREF ansiStr AS STRING, BYVAL nCodePage AS ulong = 0)
      DECLARE PROPERTY Char(BYVAL nIndex AS ulong) AS USHORT
      DECLARE PROPERTY Char(BYVAL nIndex AS ulong, BYVAL nValue AS USHORT)
      DECLARE OPERATOR [] (BYVAL nIndex AS ulong) AS USHORT
      DECLARE FUNCTION DelChars (BYVAL nIndex AS ulong, BYVAL nCount AS ulong) AS BOOLEAN
		DECLARE FUNCTION Insert (BYREF cws AS JK_CWSTR, BYVAL nIndex AS ulong) AS BOOLEAN
'      DECLARE FUNCTION Insert (BYREF cbs AS CBSTR_, BYVAL nIndex AS LONG) AS BOOLEAN
      DECLARE FUNCTION Insert (BYVAL pwszStr AS WSTRING PTR, BYVAL nIndex AS ulong) AS BOOLEAN
      DECLARE FUNCTION Insert (BYREF ansiStr AS STRING, BYVAL nIndex AS ulong, BYVAL nCodePage AS ulong = 0) AS BOOLEAN
      DECLARE OPERATOR CAST () BYREF AS WSTRING
      DECLARE OPERATOR CAST () AS ANY PTR
      DECLARE OPERATOR LET (BYREF ansiStr AS STRING)
      DECLARE OPERATOR LET (BYREF wszStr AS CONST WSTRING)
      DECLARE OPERATOR LET (BYREF pwszStr AS WSTRING PTR)
      DECLARE OPERATOR LET (BYREF cws AS JK_CWSTR)
'      DECLARE OPERATOR LET (BYREF cbs AS CBSTR_)
      DECLARE OPERATOR LET (BYVAL n AS LONGINT)
      DECLARE OPERATOR LET (BYVAL n AS DOUBLE)
'      DECLARE OPERATOR @ () AS WSTRING PTR
      DECLARE OPERATOR += (BYREF wszStr AS WSTRING)
      DECLARE OPERATOR += (BYREF cws AS JK_CWSTR)
'      DECLARE OPERATOR += (BYREF cbs AS CBSTR_)
      DECLARE OPERATOR += (BYREF ansiStr AS STRING)
      DECLARE OPERATOR += (BYVAL n AS LONGINT)
      DECLARE OPERATOR += (BYVAL n AS DOUBLE)
      DECLARE OPERATOR &= (BYREF wszStr AS WSTRING)
      DECLARE OPERATOR &= (BYREF cws AS JK_CWSTR)
'      DECLARE OPERATOR &= (BYREF cbs AS CBSTR_)
      DECLARE OPERATOR &= (BYREF ansiStr AS STRING)
      DECLARE OPERATOR &= (BYVAL n AS LONGINT)
      DECLARE OPERATOR &= (BYVAL n AS DOUBLE)
      DECLARE FUNCTION vptr () AS WSTRING PTR
      DECLARE FUNCTION sptr () AS WSTRING PTR
      DECLARE FUNCTION wstr () BYREF AS WSTRING
      DECLARE FUNCTION wchar () AS WSTRING PTR
      DECLARE PROPERTY utf8 () AS STRING
      DECLARE PROPERTY utf8 (BYREF ansiStr AS STRING)
'      DECLARE FUNCTION cbstr () AS CBSTR_
      DECLARE FUNCTION bstr () AS AFX_BSTR
      DECLARE FUNCTION LeftChars (BYVAL nChars AS LONG) AS JK_CWSTR
      DECLARE FUNCTION RightChars (BYVAL nChars AS LONG) AS JK_CWSTR
      DECLARE FUNCTION MidChars (BYVAL nStart AS LONG, BYVAL nChars AS LONG = 0) AS JK_CWSTR
      DECLARE FUNCTION ValLong () AS LONG
      DECLARE FUNCTION ValInt () AS LONG
      DECLARE FUNCTION ValULong () AS ULONG
      DECLARE FUNCTION ValUInt () AS ULONG
      DECLARE FUNCTION ValLongInt () AS LONGINT
      DECLARE FUNCTION ValULongInt () AS ULONGINT
      DECLARE FUNCTION ValDouble () AS DOUBLE
      DECLARE FUNCTION Value () AS DOUBLE

END TYPE
' ########################################################################################

' ========================================================================================
' JK_CWSTR constructors
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR Default")
   this.ResizeBuffer(m_GrowSize)   ' Create the initial buffer
   JK_CWSTR_DP("END JK_CWSTR CONSTRUCTOR Default - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR (BYVAL nChars AS ulong, BYVAL nCodePage AS ulong)
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR nChars " & .WSTR(nChars))
   m_CodePage = nCodePage          ' Store the code page
   IF nChars = 0 THEN nChars = m_GrowSize \ 2
   this.ResizeBuffer(nChars * 2)   ' Create the initial buffer
   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR nChars - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR (BYVAL pwszStr AS WSTRING PTR)
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR WSTRING - " & .WSTR(pwszStr))
   IF pwszStr = 0 THEN
      this.ResizeBuffer(m_GrowSize)   ' Create the initial buffer
   ELSE
      this.Add(pwszStr)               ' Add the passed WSTRING
   END IF
   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR WSTRING - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR (BYREF ansiStr AS STRING, BYVAL nCodePage AS ulong = 0)
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR STRING - " & .WSTR(VARPTR(ansiStr)))
   m_CodePage = nCodePage             ' Store the code page
   IF .LEN(ansiStr) THEN
      this.Add(ansiStr, nCodePage)    ' Add the passed ansi string
   ELSE
      this.ResizeBuffer(m_GrowSize)   ' Create the initial buffer
   END IF
   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR STRING - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR (BYREF cws AS JK_CWSTR)
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR JK_CWSTR")
   IF cws.m_BufferLen THEN
      this.Add(cws)                   ' Add the passed JK_CWSTR
   ELSE
      this.ResizeBuffer(m_GrowSize)   ' Create the initial buffer
   END IF
   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR JK_CWSTR - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
'PRIVATE CONSTRUCTOR JK_CWSTR (BYREF cbs AS CBStr_)
'   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR CBSTR")
'   this.ResizeBuffer(m_GrowSize)   ' Create the initial buffer
'   ' Copy the string into the buffer and update the length
'   this.AppendBuffer(cast(ANY PTR, cbs), SysStringLen(cbs) * 2)
'   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR CBSTR - " & .WSTR(m_pBuffer))
'END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR (BYVAL n AS LONGINT)
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR LONGINT")
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR LONGINT - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================
' ========================================================================================
PRIVATE CONSTRUCTOR JK_CWSTR (BYVAL n AS DOUBLE)
   JK_CWSTR_DP("+++BEGIN- JK_CWSTR CONSTRUCTOR DOUBLE")
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
   JK_CWSTR_DP("-END- JK_CWSTR CONSTRUCTOR DOUBLE - " & .WSTR(m_pBuffer))
END CONSTRUCTOR
' ========================================================================================

' ========================================================================================
' Destructor
' ========================================================================================
PRIVATE DESTRUCTOR JK_CWSTR
   JK_CWSTR_DP("***JK_CWSTR DESTRUCTOR - buffer: " & .WSTR(m_pBuffer))
   IF m_pBuffer THEN Deallocate(m_pBuffer)
   m_pBuffer = 0
END DESTRUCTOR
' ========================================================================================

' ========================================================================================
' Returns the address of the JK_CWSTR buffer.
' Removed to allow to use @ to get the address of the class.
' ========================================================================================
'PRIVATE OPERATOR JK_CWSTR.@ () AS WSTRING PTR
'   JK_CWSTR_DP("JK_CWSTR OPERATOR @ - buffer: " & .WSTR(m_pBuffer))
'   OPERATOR = cast(WSTRING PTR, m_pBuffer)
'END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.vptr () AS WSTRING PTR
   JK_CWSTR_DP("JK_CWSTR vptr - buffer: " & .WSTR(m_pBuffer))
   RETURN cast(WSTRING PTR, m_pBuffer)
END FUNCTION
' ========================================================================================

' ========================================================================================
' One * returns the address of the JK_CWSTR buffer.
' Two ** deferences the string data.
' Needed because LEFT and RIGHT (cws) fail with an ambiguous call error.
' We have to use **cws (notice the double indirection) with these functions.
' ========================================================================================
PRIVATE OPERATOR * (BYREF cws AS JK_CWSTR) AS WSTRING PTR
   JK_CWSTR_DP("JK_CWSTR OPERATOR * buffer: " & .WSTR(cws.m_pBuffer))
   OPERATOR = cast(WSTRING PTR, cws.m_pBuffer)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Returns the address of the JK_CWSTR buffer.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.sptr () AS WSTRING PTR
   JK_CWSTR_DP("JK_CWSTR sptr - buffer: " & .WSTR(m_pBuffer))
   RETURN cast(WSTRING PTR, m_pBuffer)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Returns the length, in characters, of the JK_CWSTR.
' ========================================================================================
'PRIVATE OPERATOR LEN (BYREF cws AS JK_CWSTR) AS ulong
'   JK_CWSTR_DP("JK_CWSTR OPERATOR LEN - len: " & .WSTR(.LEN(**cws)))
'   OPERATOR = .LEN(**cws)
'END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR LEN (BYREF cws AS JK_CWSTR) AS ulong
   JK_CWSTR_DP("JK_CWSTR OPERATOR LEN - len: " & .WSTR(cws.m_BufferLen \ 2))
   OPERATOR = cws.m_BufferLen \ 2
END OPERATOR
' ========================================================================================

' ========================================================================================
' Returns a pointer to the JK_CWSTR buffer.
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.CAST () AS ANY PTR
   JK_CWSTR_DP("JK_CWSTR CAST ANY PTR - buffer: " & .WSTR(m_pBuffer))
   OPERATOR = cast(ANY PTR, m_pBuffer)
END OPERATOR
' ========================================================================================
' ========================================================================================
' Returns the string data (same as **).
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.CAST () BYREF AS WSTRING
   JK_CWSTR_DP("JK_CWSTR CAST BYREF AS WSTRING - buffer: " & .WSTR(m_pBuffer))
   OPERATOR = *cast(WSTRING PTR, m_pBuffer)
END OPERATOR
' ========================================================================================
' ========================================================================================
' Returns the string data (same as **).
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.wstr () BYREF AS WSTRING
   JK_CWSTR_DP("JK_CWSTR wstr - buffer: " & .WSTR(m_pBuffer))
   RETURN *cast(WSTRING PTR, m_pBuffer)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Gets/sets the code page used to ansi to unicode translations
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.CodePage () AS ulong
   JK_CWSTR_DP("JK_CWSTR PROPERTY GET CodePage - " & .WSTR(m_CodePage))
   PROPERTY = m_CodePage
END PROPERTY
' ========================================================================================
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.CodePage (BYVAL nCodePage AS ulong)
   JK_CWSTR_DP("JK_CWSTR PROPERTY SET CodePage - " & .WSTR(nCodePage))
   m_CodePage = nCodePage
END PROPERTY
' ========================================================================================

' ========================================================================================
' Assigns new text to the JK_CWSTR.
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.Let (BYREF wszStr AS CONST WSTRING)
   JK_CWSTR_DP("JK_CWSTR LET WSTRING")
   this.Clear
   this.Add(wszStr)
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.Let (BYREF ansiStr AS STRING)
   JK_CWSTR_DP("JK_CWSTR LET STRING")
   this.Clear
   this.Add(ansiStr)
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.Let (BYREF pwszStr AS WSTRING PTR)
   JK_CWSTR_DP("JK_CWSTR LET WSTRING PTR = " & .WSTR(pwszStr))
   IF pwszStr = 0 THEN EXIT OPERATOR
   this.Clear
   this.Add(*pwszStr)
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.Let (BYREF cws AS JK_CWSTR)
   JK_CWSTR_DP("JK_CWSTR LET JK_CWSTR - m_pBuffer = " & .WSTR(m_pBuffer) & " - IN buffer = " & .WSTR(cws.m_pBuffer))
   IF m_pBuffer = cws.m_pBuffer THEN EXIT OPERATOR   ' // Ignore cws = cws
   this.Clear
   this.Add(cws)
END OPERATOR
' ========================================================================================
' ========================================================================================
'PRIVATE OPERATOR JK_CWSTR.Let (BYREF cbs AS CBStr_)
'   JK_CWSTR_DP("JK_CWSTR LET CBSTR")
'   this.Clear
'   DIM AS LONG nLenString = SysStringLen(cbs)
'   this.ResizeBuffer(nLenString)
'   ' Copy the string into the buffer and update the length
'   this.AppendBuffer(cast(ANY PTR, cbs), nLenString * 2)
'END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.Let (BYVAL n AS LONGINT)
   JK_CWSTR_DP("JK_CWSTR OPERATOR Let LONGINT")
   this.Clear
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.Let (BYVAL n AS DOUBLE)
   JK_CWSTR_DP("JK_CWSTR OPERATOR Let DOUBLE")
   this.Clear
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
END OPERATOR
' ========================================================================================

' ========================================================================================
' ResizeBuffer
' Increases the size of the internal buffer capacity
' ========================================================================================
PRIVATE SUB JK_CWSTR.ResizeBuffer (BYVAL nValue AS ulong)
   JK_CWSTR_DP("JK_CWSTR ResizeBuffer - Value = " & .WSTR(nValue))
   ' // If it is an odd value, make it even.
   IF (nValue MOD 2) <> 0 THEN nValue += 1
   ' Increase the size of the existing buffer by creating a new buffer copying
   ' the existing data into it and then finally deleting the original buffer.
   DIM pNewBuffer AS UBYTE PTR = Allocate(nValue + 2)   ' // +2 to make room for the double null terminator.
   JK_CWSTR_DP("JK_CWSTR ResizeBuffer - pNewBuffer = " & .WSTR(pNewBuffer) & " - old buffer = " & (.WSTR(m_pBuffer)))
   IF m_pBuffer THEN
      IF nValue < m_BufferLen THEN m_BufferLen = nValue
'      memcpy(pNewBuffer, m_pBuffer, m_BufferLen)
      mcpy(pNewBuffer, m_pBuffer, m_BufferLen)
      Deallocate m_pBuffer
   END IF
   m_pBuffer = pNewBuffer
   m_Capacity = nValue
   ' Mark the end of the string with a double null
   m_pBuffer[m_BufferLen] = 0
   m_pBuffer[m_BufferLen + 1] = 0
END SUB
' ========================================================================================

' ========================================================================================
' Appends the specified number of bytes from the specified memory address to the end of the buffer.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.AppendBuffer (BYVAL addrMemory AS ANY PTR, BYVAL nNumBytes AS ulong) AS BOOLEAN
   JK_CWSTR_DP("JK_CWSTR AppendBuffer " & .WSTR(m_BufferLen) & " " & .WSTR(nNumBytes))
'   IF (m_BufferLen + nNumBytes) > m_Capacity THEN this.ResizeBuffer(m_BufferLen + nNumBytes)
   ' // Add extra capacity to minimize multiple allocations when doing multiple concatenations
'   IF (m_BufferLen + nNumBytes) > m_Capacity THEN this.ResizeBuffer((m_BufferLen + nNumBytes) * 2)
   IF m_GrowSize < 0 THEN
      IF (m_BufferLen + nNumBytes) > m_Capacity THEN this.ResizeBuffer((m_BufferLen + nNumBytes) * 2)
   ELSE
      IF (m_BufferLen + nNumBytes) > m_Capacity THEN this.ResizeBuffer(m_BufferLen + nNumBytes + m_GrowSize)
   END IF
   IF m_pBuffer = 0 THEN RETURN FALSE
'   memcpy(m_pBuffer + m_BufferLen, addrMemory, nNumBytes)
   mcpy(m_pBuffer + m_BufferLen, addrMemory, nNumBytes)
   m_BufferLen += nNumBytes
   ' Mark the end of the string with a double null
   m_pBuffer[m_BufferLen] = 0
   m_pBuffer[m_BufferLen + 1] = 0
   RETURN TRUE
   JK_CWSTR_DP("--END - JK_CWSTR AppendBuffer " & .WSTR(m_BufferLen))
END FUNCTION
' ========================================================================================

' ========================================================================================
' The string parameter is appended to the string held in the class. If the internal string
' buffer overflows, the class will automatically extend it to an appropriate size.
' ========================================================================================
PRIVATE SUB JK_CWSTR.Add (BYREF cws AS JK_CWSTR)
   JK_CWSTR_DP("JK_CWSTR Add JK_CWSTR - buffer = " & .WSTR(cws.m_pBuffer) & " - LEN = " & .WSTR(LEN(*cast(WSTRING PTR, @cws))))
   ' Incoming string is already in wide format, simply copy it to the buffer.
   DIM nLenString AS ulong = cws.m_BufferLen   ' // Length in bytes
   IF nLenString = 0 THEN RETURN
   ' Copy the string into the buffer and update the length
   this.AppendBuffer(cast(ANY PTR, cws), nLenString)
END SUB
' ========================================================================================
' ========================================================================================
'PRIVATE SUB JK_CWSTR.Add (BYREF cbs AS CBSTR_)
'   JK_CWSTR_DP("JK_CWSTR Add CBSTR")
'   ' Incoming string is already in wide format, simply copy it to the buffer.
'   DIM AS LONG nLenString = SysStringLen(cbs)
'   IF nLenString = 0 THEN RETURN
'   ' Copy the string into the buffer and update the length
'   this.AppendBuffer(cast(ANY PTR, cbs), nLenString * 2)
'END SUB
' ========================================================================================
' ========================================================================================
PRIVATE SUB JK_CWSTR.Add (BYVAL pwszStr AS WSTRING PTR)
   JK_CWSTR_DP("JK_CWSTR Add WSTRING")
   IF pwszStr = 0 THEN RETURN
   ' Incoming string is already in wide format
   DIM nLenString AS ulong = .LEN(*pwszStr)   ' // Length in characters
   IF nLenString = 0 THEN RETURN
   ' Copy the string into the buffer and update the length
   this.AppendBuffer(cast(ANY PTR, pwszStr), nLenString * 2)
END SUB
' ========================================================================================
' ========================================================================================
PRIVATE SUB JK_CWSTR.Add (BYREF ansiStr AS STRING, BYVAL nCodePage AS ulong = 0)
   JK_CWSTR_DP("JK_CWSTR Add STRING Code page = " & .WSTR (nCodePage))
   IF LEN(ansiStr) = 0 THEN RETURN
   ' Create the wide string from the incoming ansi string
   DIM dwLen AS ulong, pbuffer AS ANY PTR
   IF nCodePage = 0 THEN nCodePage = m_CodePage
   IF nCodePage = JK__CP_UTF8 THEN
'      dwLen = MultiByteToWideChar(CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), NULL, 0)
      dwLen = JK__mtwc(JK__CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), 0, 0)
      IF dwLen = 0 THEN RETURN
      dwLen *= 2
      pbuffer = Allocate(dwLen)
'      MultiByteToWideChar(CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), pbuffer, dwLen)
      JK__mtwc(JK__CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), pbuffer, dwLen)
   ELSE
      dwLen = .LEN(ansiStr)
      dwLen *= 2
      pbuffer = Allocate(dwLen)
'      MultiByteToWideChar(m_CodePage, MB_PRECOMPOSED, STRPTR(ansiStr), .LEN(ansiStr), pbuffer, dwLen)
      JK__mtwc(m_CodePage, JK__MB_PRECOMPOSED, STRPTR(ansiStr), .LEN(ansiStr), pbuffer, dwLen)
   END IF
   IF pbuffer THEN
      ' Copy the string into the buffer and update the length
      this.AppendBuffer(pbuffer, dwLen)
      Deallocate(pbuffer)
   END IF
END SUB
' ========================================================================================

' ========================================================================================
' Appends a string to the JK_CWSTR
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.+= (BYREF wszStr AS WSTRING)
   JK_CWSTR_DP("JK_CWSTR OPERATOR += WSTRING")
   this.Add(wszStr)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a string to the JK_CWSTR
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.+= (BYREF ansiStr AS STRING)
   JK_CWSTR_DP("JK_CWSTR OPERATOR += STRING")
   this.Add(ansiStr)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a JK_CWSTR to the JK_CWSTR
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.+= (BYREF cws AS JK_CWSTR)
   JK_CWSTR_DP("JK_CWSTR OPERATOR += JK_CWSTR")
   this.Add(cws)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a CBSTR to the JK_CWSTR.
' ========================================================================================
'PRIVATE OPERATOR JK_CWSTR.+= (BYREF cbs AS CBStr_)
'   JK_CWSTR_DP("JK_CWSTR OPERATOR += CBSTR")
'   this.Add(cbs)
'END OPERATOR
' ========================================================================================

' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.+= (BYVAL n AS LONGINT)
   JK_CWSTR_DP("JK_CWSTR OPERATOR += LONGINT")
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.+= (BYVAL n AS DOUBLE)
   JK_CWSTR_DP("JK_CWSTR OPERATOR += DOUBLE")
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a WSTRING to the JK_CWSTR
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.&= (BYREF wszStr AS WSTRING)
   JK_CWSTR_DP("JK_CWSTR OPERATOR &= WSTRING")
   this.Add(wszStr)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a string to the JK_CWSTR
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.&= (BYREF ansiStr AS STRING)
   JK_CWSTR_DP("JK_CWSTR OPERATOR &= STRING")
   this.Add(ansiStr)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a JK_CWSTR to the JK_CWSTR
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.&= (BYREF cws AS JK_CWSTR)
   JK_CWSTR_DP("JK_CWSTR OPERATOR &= JK_CWSTR")
   this.Add(cws)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Appends a CBSTR to the JK_CWSTR.
' ========================================================================================
'PRIVATE OPERATOR JK_CWSTR.&= (BYREF cbs AS CBStr_)
'   JK_CWSTR_DP("JK_CWSTR OPERATOR &= CBSTR")
'   this.Add(cbs)
'END OPERATOR
' ========================================================================================

' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.&= (BYVAL n AS LONGINT)
   JK_CWSTR_DP("JK_CWSTR OPERATOR &= LONGINT")
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.&= (BYVAL n AS DOUBLE)
   JK_CWSTR_DP("JK_CWSTR OPERATOR &= DOUBLE")
   DIM wsz AS WSTRING * 260 = .WSTR(n)
   this.Add(wsz)
END OPERATOR
' ========================================================================================

' ========================================================================================
' Number of characters to preallocate to minimize multiple allocations when doing multiple
' concatenations. A value of less than 0 indicates that it must double the capacity each
' time that the buffer needs to be resized.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.GrowSize() AS LONG
   JK_CWSTR_DP("JK_CWSTR PROPERTY GET GrowSize")
   IF m_GrowSize > -1 THEN PROPERTY = m_GrowSize \ 2 ELSE PROPERTY = m_GrowSize
END PROPERTY
' ========================================================================================
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.GrowSize (BYVAL nChars AS LONG)
   JK_CWSTR_DP("JK_CWSTR PROPERTY SET Growsize")
   IF nChars > -1 THEN m_GrowSize = nChars * 2 ELSE m_GrowSize = -1
END PROPERTY
' ========================================================================================

' ========================================================================================
' The size of the internal string buffer is retrieved and returned to the caller. The size
' is the number of bytes which can be stored without further expansion.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.Capacity() AS ulong
   JK_CWSTR_DP("JK_CWSTR PROPERTY GET Capacity")
   PROPERTY = m_Capacity
END PROPERTY
' ========================================================================================
' ========================================================================================
' The internal string buffer is expanded to the specified number of bytes. If the new
' capacity is smaller or equal to the current capacity, no operation is performed. If it is
' smaller, the buffer is shortened and the contents that exceed the new capacity are lost.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.Capacity (BYVAL nValue AS ulong)
   JK_CWSTR_DP("JK_CWSTR PROPERTY SET Capacity")
   ' // If the new capacity is the same that the current capacity, do nothing.
   IF nValue = m_Capacity THEN EXIT PROPERTY
   ' // Make sure that the number is odd (ResizeBuffer already does it)
'   IF (nValue MOD 2) <> 0 THEN nValue += 1
   this.ResizeBuffer(nValue)
END PROPERTY
' ========================================================================================
' ========================================================================================
' The internal string buffer is expanded to the specified number of byyes.
' Sets the capacity of the buffer in characters. If the new capacity is equal to the
' current capacity, no operation is performed. If it is smaller, the buffer is shortened
' and the contents that exceed the new capacity are lost.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.SizeAlloc (BYVAL nChars AS ulong)
   JK_CWSTR_DP("JK_CWSTR PROPERTY SET SizeAlloc")
   ' // If the new capacity is the same that the current capacity, do nothing.
   IF nChars = m_Capacity \ 2 THEN EXIT PROPERTY
   this.ResizeBuffer(nChars * 2)
END PROPERTY
' ========================================================================================
' ========================================================================================
' Returns the capacity of the buffer in characters.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.SizeOf() AS ulong
   JK_CWSTR_DP("JK_CWSTR PROPERTY GET SizeOf")
   PROPERTY = m_Capacity \ 2
END PROPERTY
' ========================================================================================

' ========================================================================================
' Returns the corresponding unicode integer representation of the character at the position
' specified by the nIndex parameter (1 for the first character, 2 for the second, etc.).
' If nIndex is beyond the current length of the string, a 0 is returned.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.Char (BYVAL nIndex AS ulong) AS USHORT
   JK_CWSTR_DP("JK_CWSTR PROPERTY GET Char")
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 THEN EXIT PROPERTY
   ' Get the numeric character code at position nIndex
   nIndex -= 1
   PROPERTY = PEEK(USHORT, m_pBuffer + (nIndex * 2))
END PROPERTY
' ========================================================================================
' ========================================================================================
' Changes the corresponding unicode integer representation of the character at the position
' specified by the nIndex parameter (1 for the first character, 2 for the second, etc.).
' If nIndex is beyond the current length of the string, nothing is changed.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.Char (BYVAL nIndex AS ulong, BYVAL nValue AS USHORT)
   JK_CWSTR_DP("JK_CWSTR PROPERTY SET Char")
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 THEN EXIT PROPERTY
   ' Set the numeric character code at position nIndex (zero based)
   nIndex -= 1
   POKE USHORT, m_pBuffer + (nIndex * 2), nValue
END PROPERTY
' ========================================================================================
' ========================================================================================
' Returns the corresponding ASCII or Unicode integer representation of the character at
' the position specified by the nIndex parameter. Like the get Char property, but allowing
' to use the [] syntax, e.g. value = cws[1]. Can't be used to change a value.
' ========================================================================================
PRIVATE OPERATOR JK_CWSTR.[] (BYVAL nIndex AS ulong) AS USHORT
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 THEN EXIT OPERATOR
   ' Get the numeric character code at position nIndex
   nIndex -= 1
   OPERATOR = PEEK(USHORT, m_pBuffer + (nIndex * 2))
END OPERATOR
' ========================================================================================

' ========================================================================================
' All data in the class object is erased. Actually, we only set the buffer length to zero,
' indicating no string in the buffer. The allocated memory for the buffer is deallocated
' when the class is destroyed.
' ========================================================================================
PRIVATE SUB JK_CWSTR.Clear
   JK_CWSTR_DP("JK_CWSTR Clear")
   m_BufferLen = 0
   ' Mark the end of the string with a double null
   m_pBuffer[m_BufferLen] = 0
   m_pBuffer[m_BufferLen + 1] = 0
END SUB
' ========================================================================================

' ========================================================================================
' Resizes the string to a length of n characters.
' Parameters:
' nSize : New string length, expressed in number of characters.
' ch: Character used to fill the new character space added to the string (in case the
' string is expanded).
' If nSize is smaller than the current string length, the current value is shortened to
' its first nSize characters.
' If nSize is greater than the current string length, the current content is extended by
' inserting at the end as many characters as needed to reach a size of nSize. If ch is
' specified, the new elements are initialized as copies of ch, otherwise, spaces are added.
' ========================================================================================
PRIVATE SUB JK_CWSTR.Resize (BYVAL nSize AS ulong, BYREF ch AS WSTRING = "")
   JK_CWSTR_DP("JK_CWSTR Resize")
   IF m_BufferLen \ 2 = nSize THEN EXIT SUB
   IF m_BufferLen \ 2 > nSize THEN
      m_BufferLen = nSize * 2
      m_Capacity = nSize * 2
      m_pBuffer[m_BufferLen] = 0
      m_pBuffer[m_BufferLen + 1] = 0
   ELSE
      IF LEN(ch) > 1 THEN ch = LEFT(ch, 1)
      DIM nChars AS ulong = ((nSize * 2) - m_BufferLen) \ 2
      DIM cws AS JK_CWSTR = SPACE(nChars)
      IF ch <> "" THEN
         FOR i AS LONG = 1 TO nChars
            MID(**cws, i, 1) = ch
         NEXT
      END IF
      this.Add(cws)
   END IF
END SUB
' ========================================================================================

' ========================================================================================
' nCount characters are removed starting at the position given by nIndex.
' nIndex = 1 for the first character, 2 for the second, etc.
' Return value: If the function succeeds, it returns TRUE; otherwise, FALSE.
' Remarks: If nCount is bigger that the number of characters available to delete, the
' function deletes all the characters from nIndex to the end of the string.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.DelChars (BYVAL nIndex AS ulong, BYVAL nCount AS ulong) AS BOOLEAN
   JK_CWSTR_DP("JK_CWSTR DelChars")
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 OR nCount < 1 THEN RETURN FALSE
   DIM numChars AS ulong = m_BufferLen \ 2
   IF nCount > numChars - nIndex + 1 THEN nCount = numChars - nIndex + 1
   DIM nOffset AS ulong = (nIndex - 1 + nCount) * 2
'   memcpy(m_pBuffer + (nOffset - nCount * 2), m_pBuffer + nOffset, m_BufferLen - (nCount * 2))
   mcpy(m_pBuffer + (nOffset - nCount * 2), m_pBuffer + nOffset, m_BufferLen - (nCount * 2))
   m_BufferLen -= (nCount * 2)
   ' Mark the end of the string with a double null
   m_pBuffer[m_BufferLen] = 0
   m_pBuffer[m_BufferLen + 1] = 0
   RETURN TRUE
END FUNCTION
' ========================================================================================

' ========================================================================================
' Inserts the specified number of bytes from the specified memory address into the buffer.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.InsertBuffer (BYVAL addrMemory AS ANY PTR, BYVAL nIndex AS ulong, BYVAL nNumBytes AS ulong) AS BOOLEAN
   JK_CWSTR_DP("JK_CWSTR InsertBuffer")
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 THEN RETURN FALSE
   ' Determine the size of the new buffer
   IF m_BufferLen + nNumBytes > m_Capacity THEN m_Capacity = m_BufferLen + nNumBytes
   DIM pNewBuffer AS UBYTE PTR = Allocate((m_Capacity + 1) * 2)
   IF m_pBuffer THEN
      nIndex -= 1
      ' Copy the existing data into the new buffer
'      memcpy(pNewBuffer, m_pBuffer, nIndex * 2)
      mcpy(pNewBuffer, m_pBuffer, nIndex * 2)
      DIM nOffset AS ulong = nIndex * 2
'      memcpy(pNewBuffer + nOffset, addrMemory, nNumBytes)
      mcpy(pNewBuffer + nOffset, addrMemory, nNumBytes)
      nOffset += nNumBytes
'      memcpy(pNewBuffer + nOffset, m_pBuffer + (nIndex * 2), m_BufferLen - (nIndex * 2))
      mcpy(pNewBuffer + nOffset, m_pBuffer + (nIndex * 2), m_BufferLen - (nIndex * 2))
      Deallocate m_pBuffer
   END IF
   m_pBuffer = pNewBuffer
   m_BufferLen += nNumBytes
   ' Mark the end of the string with a double null
   m_pBuffer[m_BufferLen] = 0
   m_pBuffer[m_BufferLen + 1] = 0
   RETURN TRUE
END FUNCTION
' ========================================================================================

' ========================================================================================
' The incoming string parameter is inserted in the string starting at the position
' given by nIndex. nIndex = 1 for the first character, 2 For the second, etc.
' If nIndex is beyond the current length of the string + 1, no operation is performed.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.Insert (BYREF cws AS JK_CWSTR, BYVAL nIndex AS ulong) AS BOOLEAN
   JK_CWSTR_DP("JK_CWSTR Insert JK_CWSTR")
   IF (nIndex < 1) OR nIndex > m_BufferLen \ 2 THEN RETURN FALSE
   IF cws.m_BufferLen = 0 THEN RETURN FALSE
   RETURN this.InsertBuffer(cast(ANY PTR,cws.m_pBuffer), nIndex, cws.m_BufferLen)
END FUNCTION
' ========================================================================================
' ========================================================================================
'PRIVATE FUNCTION JK_CWSTR.Insert (BYREF cbs AS CBSTR_, BYVAL nIndex AS LONG) AS BOOLEAN
'   JK_CWSTR_DP("JK_CWSTR Insert CBSTR")
'   IF (nIndex < 1) OR nIndex > m_BufferLen \ 2 THEN RETURN 0
'   DIM AS LONG nLenString = SysStringLen(cbs)
'   IF nLenString = 0 THEN RETURN 0
'   RETURN this.InsertBuffer(cast(ANY PTR, cbs), nIndex, nLenString * 2)
'END FUNCTION
' ========================================================================================
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.Insert (BYVAL pwszStr AS WSTRING PTR, BYVAL nIndex AS ulong) AS BOOLEAN
   JK_CWSTR_DP("JK_CWSTR Insert WSTRING")
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 THEN RETURN FALSE
   DIM nLenString AS ulong = .LEN(*pwszStr)
   IF nLenString = 0 THEN RETURN FALSE
   RETURN this.InsertBuffer(cast(ANY PTR, pwszStr), nIndex, nLenString * 2)
END FUNCTION
' ========================================================================================
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.Insert (BYREF ansiStr AS STRING, BYVAL nIndex AS ulong, BYVAL nCodePage AS ulong = 0) AS BOOLEAN
   JK_CWSTR_DP("JK_CWSTR Insert STRING")
   IF nIndex < 1 OR nIndex > m_BufferLen \ 2 OR .LEN(ansiStr) = 0 THEN RETURN FALSE
   ' Create the wide string from the incoming ansi string
   DIM dwLen AS ulong, pbuffer AS ANY PTR
   IF nCodePage = 0 THEN nCodePage = m_CodePage
   IF nCodePage = JK__CP_UTF8 THEN
'      dwLen = MultiByteToWideChar(CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), NULL, 0)
      dwLen = JK__mtwc(JK__CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), 0, 0)
      IF dwLen = 0 THEN RETURN FALSE
      dwLen *= 2
      pbuffer = Allocate(dwLen)
'      MultiByteToWideChar(CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), pbuffer, dwLen)
      JK__mtwc(JK__CP_UTF8, 0, STRPTR(ansiStr), LEN(ansiStr), pbuffer, dwLen)
   ELSE
      dwLen = .LEN(ansiStr)
      dwLen *= 2
      pbuffer = Allocate(dwLen)
'      MultiByteToWideChar(m_CodePage, MB_PRECOMPOSED, STRPTR(ansiStr), .LEN(ansiStr), pbuffer, dwLen)
      JK__mtwc(m_CodePage, JK__MB_PRECOMPOSED, STRPTR(ansiStr), .LEN(ansiStr), pbuffer, dwLen)
   END IF
   ' Copy the string into the buffer and update the length
   FUNCTION = this.InsertBuffer(pbuffer, nIndex, dwLen)
   Deallocate(pbuffer)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Converts the JK_CWSTR to UTF8.
' ========================================================================================
'PRIVATE PROPERTY JK_CWSTR.Utf8 () AS STRING
'   JK_CWSTR_DP("JK_CWSTR Utf8 GET PROPERTY")
'   DIM cbLen AS INTEGER
'   IF m_BufferLen = 0 THEN RETURN ""
'   DIM buffer AS STRING = STRING(m_BufferLen * 5 + 1, 0)
'   PROPERTY = *cast(ZSTRING PTR, WCharToUTF(1, cast(WSTRING PTR, m_pBuffer), m_BufferLen, STRPTR(buffer), @cbLen))
'END PROPERTY
' ========================================================================================

' ========================================================================================
' Converts UTF8 to unicode and assigns it to the JK_CWSTR.
' ========================================================================================
PRIVATE PROPERTY JK_CWSTR.Utf8 (BYREF utf8String AS STRING)
   JK_CWSTR_DP("JK_CWSTR Utf8 SET PROPERTY")
   this.Clear
   this.Add(utf8String, JK__CP_UTF8)
END PROPERTY
' ========================================================================================

' ========================================================================================
' Returns the leftmost substring of the string.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.LeftChars (BYVAL nChars AS LONG) AS JK_CWSTR
   JK_CWSTR_DP("JK_CWSTR LeftChars")
   RETURN LEFT(*cast(WSTRING PTR, m_pBuffer), nChars)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Returns the rightmost substring of the string.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.RightChars (BYVAL nChars AS LONG) AS JK_CWSTR
   JK_CWSTR_DP("CWBSTR LeftChars")
   RETURN RIGHT(*cast(WSTRING PTR, m_pBuffer), nChars)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Returns a substring of the string.
' ========================================================================================
PRIVATE FUNCTION JK_CWSTR.MidChars (BYVAL nStart AS LONG, BYVAL nChars AS LONG = 0) AS JK_CWSTR
   JK_CWSTR_DP("JK_CWSTR MidChars")
   IF nChars = 0 THEN RETURN MID(*cast(WSTRING PTR, m_pBuffer), nStart)
   RETURN MID(*cast(WSTRING PTR, m_pBuffer), nStart, nChars)
END FUNCTION
' ========================================================================================

' =====================================================================================
' Converts the string to a 32bit integer
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValLong () AS LONG
   RETURN .ValInt(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValInt () AS LONG
   RETURN .ValInt(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================

' =====================================================================================
' Converts the string to an unsigned 32bit integer
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValULong () AS ULONG
   RETURN .ValUInt(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValUInt () AS ULONG
   RETURN .ValUInt(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================

' =====================================================================================
' Converts the string to a 64bit integer
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValLongInt () AS LONGINT
   RETURN .ValLng(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================

' =====================================================================================
' Converts the string to an unsigned 64bit integer
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValULongInt () AS ULONGINT
   RETURN .ValULng(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================

' =====================================================================================
' Converts the string to a floating point number (DOUBLE)
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.ValDouble () AS DOUBLE
   RETURN .VAL(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================
' =====================================================================================
PRIVATE FUNCTION JK_CWSTR.Value () AS DOUBLE
   RETURN .VAL(*cast(WSTRING PTR, m_pBuffer))
END FUNCTION
' =====================================================================================

' =====================================================================================
' Returns the contents of the JK_CWSTR as a CBSTR.
' Useful to pass a JK_CWSTR to a function that expects a BYVAL IN BSTR parameter.
' =====================================================================================
'PRIVATE FUNCTION JK_CWSTR.cbstr () AS CBStr_
'   RETURN SysAllocString(cast(WSTRING PTR, m_pBuffer))
'END FUNCTION
' =====================================================================================


'***********************************************************************************************
' dont need this without WinFBX !!!
'***********************************************************************************************

'' =====================================================================================
'' Returns the contents of the JK_CWSTR as a BSTR.
'' =====================================================================================
'PRIVATE FUNCTION JK_CWSTR.bstr () AS AFX_BSTR
'   RETURN SysAllocString(cast(WSTRING PTR, m_pBuffer))
'END FUNCTION
'' =====================================================================================
'
'' =====================================================================================
'' Returns the contents of the JK_CWSTR as a WSTRING allocated with CoTaskMemAlloc.
'' Free the returned string later with CoTaskMemFree.
'' Note: This is useful when we need to pass a pointer to a null terminated wide string to a
'' function or method that will release it. If we pass a WSTRING it will GPF.
'' If the length of the input string is 0, CoTaskMemAlloc allocates a zero-length item and
'' returns a valid pointer to that item. If there is insufficient memory available,
'' CoTaskMemAlloc returns NULL.
'' =====================================================================================
'PRIVATE FUNCTION JK_CWSTR.wchar () AS WSTRING PTR
'   DIM pwchar AS WSTRING PTR
'   pwchar = CoTaskMemAlloc((m_BufferLen + 1) * 2)
'   IF pwchar = NULL THEN RETURN NULL
'   IF m_BufferLen THEN memcpy pwchar, m_pBuffer, m_BufferLen
'   IF m_BufferLen = 0 THEN *pwchar = CHR(0)
'   RETURN pwchar
'END FUNCTION
'' =====================================================================================


END NAMESPACE

' ########################################################################################
'                               *** GLOBAL OPERATORS ***
' ########################################################################################

' // Outside a namespace because they are global
'using JK

' ========================================================================================
PRIVATE OPERATOR & (BYREF cws1 AS JK.JK_CWSTR, BYREF cws2 AS JK.JK_CWSTR) AS JK.JK_CWSTR
   DIM cwsRes AS JK.JK_CWSTR = cws1
   cwsRes.Add(cws2)
   OPERATOR = cwsRes
END OPERATOR
' ========================================================================================
' ========================================================================================
PRIVATE FUNCTION Left OVERLOAD (BYREF cws AS JK.JK_CWSTR, BYVAL nChars AS INTEGER) AS JK.JK_CWSTR
   RETURN LEFT(*cast(WSTRING PTR, cws.m_pBuffer), nChars)
END FUNCTION
' ========================================================================================
' ========================================================================================
PRIVATE FUNCTION Right OVERLOAD (BYREF cws AS JK.JK_CWSTR, BYVAL nChars AS INTEGER) AS JK.JK_CWSTR
   RETURN RIGHT(*cast(WSTRING PTR, cws.m_pBuffer), nChars)
END FUNCTION
' ========================================================================================
' ========================================================================================
PRIVATE FUNCTION Val OVERLOAD (BYREF cws AS JK.JK_CWSTR) AS DOUBLE
   RETURN .VAL(*cast(WSTRING PTR, cws.m_pBuffer))
END FUNCTION

' ########################################################################################
'                                *** HELPER FUNCTIONS ***
' ########################################################################################
'
'' ========================================================================================
'' qsort JK_CWSTR comparison function
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayCompare CDECL (BYVAL a AS JK_CWSTR PTR, BYVAL b AS JK_CWSTR PTR) AS LONG
'   FUNCTION = wcscmp(cast(WSTRING PTR, a->m_pBuffer), cast(WSTRING PTR, b->m_pBuffer))
'END FUNCTION
'' ========================================================================================
'' ========================================================================================
'' Reverse qsort JK_CWSTR comparison function
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayReverseCompare CDECL (BYVAL a AS JK_CWSTR PTR, BYVAL b AS JK_CWSTR PTR) AS LONG
'   DIM r AS LONG = wcscmp(cast(WSTRING PTR, a->m_pBuffer), cast(WSTRING PTR, b->m_pBuffer))
'   IF r = 1 THEN r = -1 ELSE IF r = -1 THEN r = 1
'   RETURN r
'END FUNCTION
'' ========================================================================================
'
'' ========================================================================================
'' Sorts a one-dimensional JK_CWSTR array calling the C qsort function.
'' Parameters:
'' - rgwstr : Start of target array.
'' - numElm : Number of elements in the array.
'' - bAscend: TRUE for sorting in ascending order; FALSE for sorting in descending order.
'' Example:
'' DIM rg(1 TO 10) AS JK_CWSTR
'' FOR i AS LONG = 1 TO 10
''    rg(i) = "string " & i
'' NEXT
'' FOR i AS LONG = 1 TO 10
''   print rg(i)
'' NEXT
'' print "---- after sorting ----"
'' AfxJK_CWSTRSort @rg(1), 10, TRUE
'' FOR i AS LONG = 1 TO 10
''    print rg(i)
'' NEXT
'' ========================================================================================
'PRIVATE SUB AfxJK_CWSTRSort (BYREF rgwstr AS ANY PTR, BYVAL numElm AS LONG, BYVAL bAscend AS BOOLEAN = TRUE)
'   IF rgwstr = NULL OR numElm < 2 THEN EXIT SUB
'   IF bAscend THEN
'      qsort rgwstr, numElm, SIZEOF(JK_CWSTR), CPTR(ANY PTR, @AfxJK_CWSTRArrayCompare)
'   ELSE
'      qsort rgwstr, numElm, SIZEOF(JK_CWSTR) , CPTR(ANY PTR, @AfxJK_CWSTRArrayReverseCompare)
'   END IF
'END SUB
'' ========================================================================================
'' ========================================================================================
'PRIVATE SUB AfxJK_CWSTRArraySort (rgwstr() AS JK_CWSTR, BYVAL bAscend AS BOOLEAN = TRUE)
'   DIM numElm AS LONG = UBOUND(rgwstr) - LBOUND(rgwstr) + 1
'   AfxJK_CWSTRSort @rgwstr(LBOUND(rgwstr)), numElm, bAscend
'END SUB
'' ========================================================================================
'
'' ========================================================================================
'' Appends a JK_CWSTR at the end of a one-dimensional JK_CWSTR array.
'' Parameters:
'' - rgwstr(): The JK_CWSTR array
'' - cws: The JK_CWSTR to append
'' Return value:
''   TRUE or FALSE
'' Example:
'' #INCLUDE ONCE "Afx/JK_CWSTR.inc"
'' USING Afx
'' REDIM rg(1 TO 10) AS JK_CWSTR
'' FOR i AS LONG = 1 TO 10
''    rg(i) = "string " & i
'' NEXT
'' AfxJK_CWSTRArrayAppend(rg(), "string 11")
'' FOR i AS LONG = LBOUND(rg) TO UBOUND(rg)
''    print rg(i)
'' NEXT
'' Note: REDIM PRESERVE cannot be used on fixed-size arrays - i.e. arrays with constant bounds
'' made with DIM. If after calling REDIM PRESERVE the upper bound has not changed, it means
'' that it is a fixed string.
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayAppend (rgwstr() AS JK_CWSTR, BYREF cws AS JK_CWSTR) AS BOOLEAN
'   DIM upperBound AS LONG = UBOUND(rgwstr)
'   REDIM PRESERVE rgwstr(LBOUND(rgwstr) TO upperBound + 1) AS JK_CWSTR
'   IF UBOUND(rgwstr) > upperBound THEN rgwstr(UBOUND(rgwstr)) = cws : RETURN TRUE
'   RETURN FALSE
'END FUNCTION
'' ========================================================================================
'
'' ========================================================================================
'' Inserts a new JK_CWSTR element before the specified position in a one-dimensional JK_CWSTR array.
'' Parameters:
'' - rgwstr(): The JK_CWSTR array
'' - nPos: The position in the array where the new element will be added.
''         This position is relative to the lower bound of the array.
'' - cws: The JK_CWSTR to append
'' Return value:
''   TRUE or FALSE
'' Example:
'' #INCLUDE ONCE "Afx/JK_CWSTR.inc"
'' USING Afx
'' REDIM rg(1 TO 10) AS JK_CWSTR
'' FOR i AS LONG = 1 TO 10
''    rg(i) = "string " & i
'' NEXT
'' AfxJK_CWSTRArrayInsert(rg(), 3, "Inserted element")
'' FOR i AS LONG = LBOUND(rg) TO UBOUND(rg)
''    print rg(i)
'' NEXT
'' Note: REDIM PRESERVE cannot be used on fixed-size arrays - i.e. arrays with constant bounds
'' made with DIM. If after calling REDIM PRESERVE the upper bound has not changed, it means
'' that it is a fixed string.
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayInsert (rgwstr() AS JK_CWSTR, BYVAL nPos AS LONG, BYREF cws AS JK_CWSTR) AS BOOLEAN
'   DIM lowerBound AS LONG = LBOUND(rgwstr)
'   DIM upperBound AS LONG = UBOUND(rgwstr)
'   nPos = nPos - 1 + lowerBound
'   IF nPos < lowerBound OR nPos > upperBound THEN RETURN FALSE
'   REDIM PRESERVE rgwstr(lowerBound TO upperBound + 1) AS JK_CWSTR
'   IF UBOUND(rgwstr) = upperBound THEN RETURN FALSE
'   ' // Move all the elements down
'   FOR i AS LONG = UBOUND(rgwstr) TO nPos + 1 STEP - 1
'      rgwstr(i) = rgwstr(i - 1)
'   NEXT
'   rgwstr(nPos) = cws
'   RETURN TRUE
'END FUNCTION
'' ========================================================================================
'
'' ========================================================================================
'' Removes the specified element of a one-dimensional JK_CWSTR array.
'' Parameters:
'' - rgwstr(): The JK_CWSTR array
'' - nPos: The position in the array of the element to remove.
''         This position is relative to the lower bound of the array.
'' - cws: The JK_CWSTR to append
'' Return value:
''   TRUE or FALSE
'' Example:
'' #INCLUDE ONCE "Afx/JK_CWSTR.inc"
'' USING Afx
'' REDIM rg(1 TO 10) AS JK_CWSTR
'' FOR i AS LONG = 1 TO 10
''    rg(i) = "string " & i
'' NEXT
'' AfxJK_CWSTRArrayRemove(rg(), 3)
'' FOR i AS LONG = LBOUND(rg) TO UBOUND(rg)
''    print rg(i)
'' NEXT
'' Note: REDIM PRESERVE cannot be used on fixed-size arrays - i.e. arrays with constant bounds
'' made with DIM. If after calling REDIM PRESERVE the upper bound has not changed, it means
'' that it is a fixed string.
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayRemove (rgwstr() AS JK_CWSTR, BYVAL nPos AS LONG) AS BOOLEAN
'   DIM lowerBound AS LONG = LBOUND(rgwstr)
'   DIM upperBound AS LONG = UBOUND(rgwstr)
'   nPos = nPos - 1 + lowerBound
'   IF nPos < lowerBound OR nPos > upperBound THEN RETURN FALSE
'   FOR i AS LONG = nPos TO upperBound - 1
'      rgwstr(i) = rgwstr(i + 1)
'   NEXT
'   REDIM PRESERVE rgwstr(lowerBound TO upperBound - 1) AS JK_CWSTR
'   IF UBOUND(rgwstr) = upperBound THEN RETURN FALSE
'   RETURN TRUE
'END FUNCTION
'' ========================================================================================
'
'' ========================================================================================
'' Removes the first element of a one-dimensional JK_CWSTR array.
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayRemoveFirst (rgwstr() AS JK_CWSTR) AS BOOLEAN
'   DIM lowerBound AS LONG = LBOUND(rgwstr)
'   DIM upperBound AS LONG = UBOUND(rgwstr)
'   DIM nPos AS LONG = lowerBound
'   FOR i AS LONG = nPos TO upperBound - 1
'      rgwstr(i) = rgwstr(i + 1)
'   NEXT
'   REDIM PRESERVE rgwstr(lowerBound TO upperBound - 1) AS JK_CWSTR
'   IF UBOUND(rgwstr) = upperBound THEN RETURN FALSE
'   RETURN TRUE
'END FUNCTION
'' ========================================================================================
'
'' ========================================================================================
'' Removes the last element of a one-dimensional JK_CWSTR array.
'' ========================================================================================
'PRIVATE FUNCTION AfxJK_CWSTRArrayRemoveLast (rgwstr() AS JK_CWSTR) AS BOOLEAN
'   DIM lowerBound AS LONG = LBOUND(rgwstr)
'   DIM upperBound AS LONG = UBOUND(rgwstr)
'   REDIM PRESERVE rgwstr(lowerBound TO upperBound - 1) AS JK_CWSTR
'   IF UBOUND(rgwstr) = upperBound THEN RETURN FALSE
'   RETURN TRUE
'END FUNCTION
'' ========================================================================================


